#!/bin/sh
headerList=`ls *.h | grep -v MG5matrix | grep -v MG5parameters`
(
    date=`date`
    echo "// List of MG5 wrappers for VINCIA"
    echo "// Generated on "$date" by "$0
    echo "// Any changes to this file must be done by updating $0"
    echo ""
    echo "// Include MG5 C++ parameter definitions"
    echo '#include "VinciaMG5/MG5parameters_sm.h"'
    echo ""
    echo "// Include MG5 ME-wrapper base class(es)"
    echo '#include "VinciaMG5/MG5matrix.h"'
    echo ""
    echo "// Then include derived classes"
    for header in $headerList; do
        echo '#include "VinciaMG5/'${header}'"'
    done
) > allHeaders.inc

