C...dxd_dxdg.f is a part of the VINCIA event generator.
C...This file was generated by MADGRAPH 5
C...Modified by VINCIA Thu  8 Jun 2017 15:37:53 CEST
C...VINCIA is licenced under the GNU GPL version 2.
C...Copyright (C) 2017 Peter Skands
C...Please respect the work of the MadGraph authors by
C...citing MadGraph 5 when this part of VINCIA is used.
C...See: https://arxiv.org/abs/1106.0522
 
      SUBROUTINE SHELdxd_dxdg(MCMODE,ICOL,P,HEL,ANS)
      IMPLICIT NONE
C     
C     CONSTANT
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=5)
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=32)
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: HEL
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)

C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER HEL
C     
C     GLOBAL VARIABLES
C     
      INTEGER USERHEL
      COMMON/HELUSERCHOICE/USERHEL
C     ----------
C     BEGIN CODE
C     ----------
      USERHEL=HEL
      CALL Sdxd_dxdg(MCMODE,ICOL,P,ANS)
      USERHEL=-1

      END

      SUBROUTINE Sdxd_dxdg(MCMODE,ICOL,P,ANS)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.4.2, 2016-06-10
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     MadGraph5_aMC@NLO StandAlone Version
C     
C     Returns amplitude squared summed/avg over colors
C     and helicities
C     for the point in phase space P(0:3,NEXTERNAL)
C     
C     Process: d~ d > d~ d g WEIGHTED<=3 @410
C     Process: u~ u > u~ u g WEIGHTED<=3 @410
C     Process: s~ s > s~ s g WEIGHTED<=3 @410
C     Process: c~ c > c~ c g WEIGHTED<=3 @410
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=5)
      INTEGER    NINITIAL
      PARAMETER (NINITIAL=2)
      INTEGER NPOLENTRIES
      PARAMETER (NPOLENTRIES=(NEXTERNAL+1)*6)
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=32)
      INTEGER HELAVGFACTOR
      PARAMETER (HELAVGFACTOR=4)
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)
C     
C     LOCAL VARIABLES 
C     
      INTEGER NHEL(NEXTERNAL,NCOMB),NTRY
      DOUBLE PRECISION T
      DOUBLE PRECISION dxd_dxdg
      INTEGER IHEL,IDEN, I, J
C     For a 1>N process, them BEAMTWO_HELAVGFACTOR would be set to 1.
      INTEGER BEAMS_HELAVGFACTOR(2)
      DATA (BEAMS_HELAVGFACTOR(I),I=1,2)/2,2/
      INTEGER JC(NEXTERNAL)
      LOGICAL GOODHEL(NCOMB)
      DATA NTRY/0/
      DATA GOODHEL/NCOMB*.FALSE./

C     
C     GLOBAL VARIABLES
C     
      INTEGER USERHEL
      COMMON/HELUSERCHOICE/USERHEL
C...VINCIA: USERHEL is initialised by MG5interface
C      DATA USERHEL/-1/

      DATA (NHEL(I,   1),I=1,5) /-1, 1, 1,-1,-1/
      DATA (NHEL(I,   2),I=1,5) /-1, 1, 1,-1, 1/
      DATA (NHEL(I,   3),I=1,5) /-1, 1, 1, 1,-1/
      DATA (NHEL(I,   4),I=1,5) /-1, 1, 1, 1, 1/
      DATA (NHEL(I,   5),I=1,5) /-1, 1,-1,-1,-1/
      DATA (NHEL(I,   6),I=1,5) /-1, 1,-1,-1, 1/
      DATA (NHEL(I,   7),I=1,5) /-1, 1,-1, 1,-1/
      DATA (NHEL(I,   8),I=1,5) /-1, 1,-1, 1, 1/
      DATA (NHEL(I,   9),I=1,5) /-1,-1, 1,-1,-1/
      DATA (NHEL(I,  10),I=1,5) /-1,-1, 1,-1, 1/
      DATA (NHEL(I,  11),I=1,5) /-1,-1, 1, 1,-1/
      DATA (NHEL(I,  12),I=1,5) /-1,-1, 1, 1, 1/
      DATA (NHEL(I,  13),I=1,5) /-1,-1,-1,-1,-1/
      DATA (NHEL(I,  14),I=1,5) /-1,-1,-1,-1, 1/
      DATA (NHEL(I,  15),I=1,5) /-1,-1,-1, 1,-1/
      DATA (NHEL(I,  16),I=1,5) /-1,-1,-1, 1, 1/
      DATA (NHEL(I,  17),I=1,5) / 1, 1, 1,-1,-1/
      DATA (NHEL(I,  18),I=1,5) / 1, 1, 1,-1, 1/
      DATA (NHEL(I,  19),I=1,5) / 1, 1, 1, 1,-1/
      DATA (NHEL(I,  20),I=1,5) / 1, 1, 1, 1, 1/
      DATA (NHEL(I,  21),I=1,5) / 1, 1,-1,-1,-1/
      DATA (NHEL(I,  22),I=1,5) / 1, 1,-1,-1, 1/
      DATA (NHEL(I,  23),I=1,5) / 1, 1,-1, 1,-1/
      DATA (NHEL(I,  24),I=1,5) / 1, 1,-1, 1, 1/
      DATA (NHEL(I,  25),I=1,5) / 1,-1, 1,-1,-1/
      DATA (NHEL(I,  26),I=1,5) / 1,-1, 1,-1, 1/
      DATA (NHEL(I,  27),I=1,5) / 1,-1, 1, 1,-1/
      DATA (NHEL(I,  28),I=1,5) / 1,-1, 1, 1, 1/
      DATA (NHEL(I,  29),I=1,5) / 1,-1,-1,-1,-1/
      DATA (NHEL(I,  30),I=1,5) / 1,-1,-1,-1, 1/
      DATA (NHEL(I,  31),I=1,5) / 1,-1,-1, 1,-1/
      DATA (NHEL(I,  32),I=1,5) / 1,-1,-1, 1, 1/
      DATA IDEN/36/

      INTEGER POLARIZATIONS(0:NEXTERNAL,0:5)
      DATA ((POLARIZATIONS(I,J),I=0,NEXTERNAL),J=0,5)/NPOLENTRIES*-1/
C...Vincia: BORN_BEAM_POL not used (POLARIZATIONS local and = -1)
C      COMMON/BORN_BEAM_POL/POLARIZATIONS
C     
C     FUNCTIONS
C     
C...Vincia conversion hardcodes for IS_BORN_HEL_SELECTED = .TRUE.
C      LOGICAL IS_BORN_HEL_SELECTED

C     ----------
C     BEGIN CODE
C     ----------
      IF(USERHEL.EQ.-1) NTRY=0
C...(VINCIA: no NTRY optimisation)
      DO IHEL=1,NEXTERNAL
        JC(IHEL) = +1
      ENDDO
C     When spin-2 particles are involved, the Helicity filtering is
C      dangerous for the 2->1 topology.
C     This is because depending on the MC setup the initial PS points
C      have back-to-back initial states
C     for which some of the spin-2 helicity configurations are zero.
C      But they are no longer zero
C     if the point is boosted on the z-axis. Remember that HELAS
C      helicity amplitudes are no longer
C     lorentz invariant with expternal spin-2 particles (only the
C      helicity sum is).
C     For this reason, we simply remove the filterin when there is
C      only three external particles.
      IF (NEXTERNAL.LE.3) THEN
        DO IHEL=1,NCOMB
          GOODHEL(IHEL)=.TRUE.
        ENDDO
      ENDIF
      ANS = 0D0
      DO IHEL=1,NCOMB
        IF (USERHEL.EQ.-1.OR.USERHEL.EQ.IHEL) THEN
          IF (GOODHEL(IHEL) .OR. NTRY .LT. 20.OR.USERHEL.NE.-1) THEN
            IF(NTRY.GE.2.AND.POLARIZATIONS(0,0).NE.
     $       -1.AND.(.FALSE.)) THEN
              CYCLE
            ENDIF
            T=dxd_dxdg(MCMODE,ICOL,P ,NHEL(1,IHEL),JC(1))
            IF(POLARIZATIONS(0,0).EQ.-1.OR..TRUE.)
     $        THEN
              ANS=ANS+T
            ENDIF
            IF (T .NE. 0D0 .AND. .NOT.    GOODHEL(IHEL)) THEN
              GOODHEL(IHEL)=.TRUE.
            ENDIF
          ENDIF
        ENDIF
      ENDDO

C...VINCIA: Only normalise by Bose factor if doing full colour
      IF (MCMODE.EQ.2) ANS=ANS/DBLE(IDEN)
      IF(USERHEL.NE.-1) THEN
C...Cancel helicity-averaging factor when doing helicity amplitudes
        ANS=ANS*HELAVGFACTOR
      ELSE
        DO J=1,NINITIAL
          IF (POLARIZATIONS(J,0).NE.-1) THEN
C...Cancel helicity-averaging factor when doing helicity amplitudes
            ANS=ANS*BEAMS_HELAVGFACTOR(J)
      
C...VINCIA: Only normalise by Bose factor if doing full colour
      IF (MCMODE.EQ.2) ANS=ANS/POLARIZATIONS(J,0)
          ENDIF
        ENDDO
      ENDIF
      END


      DOUBLE PRECISION FUNCTION dxd_dxdg(MCMODE,ICOL,P,NHEL,IC)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.4.2, 2016-06-10
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Returns amplitude squared summed/avg over colors
C     for the point with external lines W(0:6,NEXTERNAL)
C     
C     Process: d~ d > d~ d g WEIGHTED<=3 @410
C     Process: u~ u > u~ u g WEIGHTED<=3 @410
C     Process: s~ s > s~ s g WEIGHTED<=3 @410
C     Process: c~ c > c~ c g WEIGHTED<=3 @410
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=10)
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=5)
      INTEGER    NWAVEFUNCS, NCOLOR
      PARAMETER (NWAVEFUNCS=11, NCOLOR=4)
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
      DOUBLE PRECISION ZLCSUM, FSLC
      COMPLEX*16 IMAG1
      PARAMETER (IMAG1=(0D0,1D0))
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,J
      COMPLEX*16 ZTEMP
      DOUBLE PRECISION DENOM(NCOLOR), CF(NCOLOR,NCOLOR)
      COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR)
      COMPLEX*16 W(20,NWAVEFUNCS)
      COMPLEX*16 DUM0,DUM1
      DATA DUM0, DUM1/(0D0, 0D0), (1D0, 0D0)/
C     
C     GLOBAL VARIABLES
C     
      INCLUDE 'coupl.inc'

C     
C     COLOR DATA
C     
      DATA DENOM(1)/1/
      DATA (CF(I,  1),I=  1,  4) /   12,    4,    4,    0/
C     1 T(1,2) T(5,4,3)
      DATA DENOM(2)/1/
      DATA (CF(I,  2),I=  1,  4) /    4,   12,    0,    4/
C     1 T(1,3) T(5,4,2)
      DATA DENOM(3)/1/
      DATA (CF(I,  3),I=  1,  4) /    4,    0,   12,    4/
C     1 T(4,2) T(5,1,3)
      DATA DENOM(4)/1/
      DATA (CF(I,  4),I=  1,  4) /    0,    4,    4,   12/
C     1 T(4,3) T(5,1,2)
C     ----------
C     BEGIN CODE
C     ----------
      CALL OXXXXX(P(0,1),ZERO,NHEL(1),-1*IC(1),W(1,1))
      CALL IXXXXX(P(0,2),ZERO,NHEL(2),+1*IC(2),W(1,2))
      CALL IXXXXX(P(0,3),ZERO,NHEL(3),-1*IC(3),W(1,3))
      CALL OXXXXX(P(0,4),ZERO,NHEL(4),+1*IC(4),W(1,4))
      CALL VXXXXX(P(0,5),ZERO,NHEL(5),+1*IC(5),W(1,5))
      CALL FFV1P0_3(W(1,2),W(1,1),GC_11,ZERO,ZERO,W(1,6))
      CALL FFV1P0_3(W(1,3),W(1,4),GC_11,ZERO,ZERO,W(1,7))
C     Amplitude(s) for diagram number 1
      CALL VVV1_0(W(1,6),W(1,7),W(1,5),GC_10,AMP(1))
      CALL FFV1_2(W(1,3),W(1,5),GC_11,ZERO,ZERO,W(1,8))
C     Amplitude(s) for diagram number 2
      CALL FFV1_0(W(1,8),W(1,4),W(1,6),GC_11,AMP(2))
      CALL FFV1_1(W(1,4),W(1,5),GC_11,ZERO,ZERO,W(1,9))
C     Amplitude(s) for diagram number 3
      CALL FFV1_0(W(1,3),W(1,9),W(1,6),GC_11,AMP(3))
      CALL FFV1P0_3(W(1,3),W(1,1),GC_11,ZERO,ZERO,W(1,6))
      CALL FFV1P0_3(W(1,2),W(1,4),GC_11,ZERO,ZERO,W(1,10))
C     Amplitude(s) for diagram number 4
      CALL VVV1_0(W(1,6),W(1,10),W(1,5),GC_10,AMP(4))
      CALL FFV1_2(W(1,2),W(1,5),GC_11,ZERO,ZERO,W(1,11))
C     Amplitude(s) for diagram number 5
      CALL FFV1_0(W(1,11),W(1,4),W(1,6),GC_11,AMP(5))
C     Amplitude(s) for diagram number 6
      CALL FFV1_0(W(1,2),W(1,9),W(1,6),GC_11,AMP(6))
      CALL FFV1_1(W(1,1),W(1,5),GC_11,ZERO,ZERO,W(1,6))
C     Amplitude(s) for diagram number 7
      CALL FFV1_0(W(1,3),W(1,6),W(1,10),GC_11,AMP(7))
C     Amplitude(s) for diagram number 8
      CALL FFV1_0(W(1,2),W(1,6),W(1,7),GC_11,AMP(8))
C     Amplitude(s) for diagram number 9
      CALL FFV1_0(W(1,8),W(1,1),W(1,10),GC_11,AMP(9))
C     Amplitude(s) for diagram number 10
      CALL FFV1_0(W(1,11),W(1,1),W(1,7),GC_11,AMP(10))
      JAMP(1)=+1D0/2D0*(+1D0/3D0*AMP(2)+1D0/3D0*AMP(3)-IMAG1*AMP(4)
     $ +AMP(6)+AMP(9))
      JAMP(2)=+1D0/2D0*(+IMAG1*AMP(1)-AMP(3)-1D0/3D0*AMP(5)-1D0/3D0
     $ *AMP(6)-AMP(10))
      JAMP(3)=+1D0/2D0*(-IMAG1*AMP(1)-AMP(2)-1D0/3D0*AMP(7)-AMP(8)-1D0
     $ /3D0*AMP(9))
      JAMP(4)=+1D0/2D0*(+IMAG1*AMP(4)+AMP(5)+AMP(7)+1D0/3D0*AMP(8)+1D0
     $ /3D0*AMP(10))

C...VINCIA: Leading Color for Diagonal Entry ICOL
      dxd_dxdg = CF(ICOL,ICOL)*JAMP(ICOL)
     &         *DCONJG(JAMP(ICOL))/DENOM(ICOL)
C...VINCIA: Absorb subleading color proportional to FSLC = LC/Sum(LC)
      IF (MCMODE.EQ.0) RETURN
      IF (MCMODE.EQ.1.AND.dxd_dxdg.LE.ZERO) RETURN
        ZLCSUM = 0D0
        DO I = 1, NCOLOR
          ZLCSUM = ZLCSUM + CF(I,I)*JAMP(I)*DCONJG(JAMP(I))/DENOM(I)
        ENDDO
C...VINCIA: MCMODE = 2 returns full colour-summed ME
        IF (MCMODE.EQ.2) dxd_dxdg = ZLCSUM
C...VINCIA: Fraction of subleading color to absorb into this permutation
        FSLC = dxd_dxdg/ZLCSUM
C...VINCIA: Sum over subleading contributions multiplied by FSLC
      DO I = 1, NCOLOR
        ZTEMP = (0.D0,0.D0)
        DO J = 1, NCOLOR
          IF (I.NE.J) ZTEMP = ZTEMP + CF(J,I)*JAMP(J)
        ENDDO
        dxd_dxdg = dxd_dxdg+FSLC*ZTEMP*DCONJG(JAMP(I))/DENOM(I)
      ENDDO

      END

      SUBROUTINE GETdxd_dxdg(MCMODE,ICOL,P, ALPHAS, NHEL ,ANS)
      IMPLICIT NONE
C     
C     CONSTANT
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=5)
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION ANS, P(0:3,NEXTERNAL)
C...VINCIA: Define MCMODE and ICOL variables
C...  MCMODE = 0 : Leading Colour = LC[icol]
C...  MCMODE = 1 : Vincia Colour  = FC * LC[icol]/sum(LC)
C...  MCMODE = 2 : Full Colour    = FC (-> normal MG mode)
      INTEGER MCMODE, ICOL
      INTEGER NHEL
      DOUBLE PRECISION ALPHAS
      DOUBLE PRECISION PI
CF2PY INTENT(OUT) :: ANS
CF2PY INTENT(IN) :: NHEL
CF2PY INTENT(IN) :: P(0:3,NEXTERNAL)
CF2PY INTENT(IN) :: ALPHAS
C     ROUTINE FOR F2PY to read the benchmark point.    
C     the include file with the values of the parameters and masses 
      INCLUDE 'coupl.inc'

      PI = 3.141592653589793D0
      G = 2* DSQRT(ALPHAS*PI)
C...VINCIA: only static MG couplings are interfaced
C      CALL UPDATE_AS_PARAM()
      IF (NHEL.NE.0) THEN
        CALL SHELdxd_dxdg(MCMODE,ICOL,P, NHEL, ANS)
      ELSE
        CALL Sdxd_dxdg(MCMODE,ICOL,P, ANS)
      ENDIF
      RETURN
      END


